package com.bbva.pzic.claims.facade.v0;

import com.bbva.jee.arq.spring.core.catalog.gabi.ServiceResponse;
import com.bbva.jee.arq.spring.core.catalog.gabi.ServiceResponseNoContent;
import com.bbva.pzic.claims.canonic.AutomaticRefundTransaction;
import com.bbva.pzic.claims.canonic.ProductClaimTransaction;
import com.bbva.pzic.claims.facade.v0.dto.*;

import javax.activation.DataSource;
import java.util.List;

/**
 * Created on 16/09/2018.
 *
 * @author Entelgy
 */
public interface ISrvClaimsV0 {
    /**
     * It allows to consult the list of money reimbursement requirements made by
     * a customer.
     *
     * @param customerId
     * @return {@link List<AutomaticRefundTransaction>}
     */
    ServiceResponse<List<AutomaticRefundTransaction>> listAutomaticRefundTransactions(String customerId);

    /**
     * It allows to consult the detail of a money refund requirement made by a
     * customer, where you can also know the status of the request, if it was
     * accepted or rejected.
     *
     * @param automaticRefundTransactionId automatic refund transaction identifier.
     * @return {@link AutomaticRefundTransaction}
     */
    ServiceResponse<AutomaticRefundTransaction> getAutomaticRefundTransaction(
            String automaticRefundTransactionId);
    /**
     * Administration of claims and requests generated by clients or not clients of the bank,
     * whether individuals or companies, for the purpose of expressing only disagreement
     * on specific products when making use of them directly or indirectly.
     *
     * @param productClaim
     * @return {@link ServiceResponse<ProductClaimTransaction>}
     */
    ProductClaimTransactionData createProductClaim(String productClaim,
                                                   List<DataSource> attachments);
    /**
     * It allows to evaluate a requirement of money reimbursement by a customer,
     * this requirement must go through a series of validation filters by means
     * of a rules engine, to finally decide if the request is accepted or
     * rejected.
     *
     * @param automaticRefundTransaction payload
     * @return {@link AutomaticRefundTransaction}
     */
    ServiceResponse<AutomaticRefundTransaction> validateAutomaticRefundTransaction(
            AutomaticRefundTransaction automaticRefundTransaction);

    ListProductClaimsData searchProductClaims(Search search);

    ProductClaimsData getProductClaim(String productClaimId, String expand);

    ServiceResponseNoContent sendEmailProductClaim(String productClaimId, SendEmail sendEmail);

    ServiceResponse<PartialTransaction> modifyPartialAutomaticRefundTransaction(String automaticRefundTransactionId,
                                                                                AutomaticRefundTransactionF automaticRefundTransaction);
}
